/* --------------------------------------------------------
   4FĂ݂
   (DTŒׂ)

                                     2003/11/14
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -------------------------------------------------------- */
#define AREA_LIMIT      (8)
#define AREA_A          (0)
#define AREA_B          (1)
#define AREA_C          (2)
#define AREA_D          (3)
#define AREA_E          (4)
#define AREA_F          (5)
#define AREA_G          (6)
#define AREA_H          (7)
#define AREA_END        (8)
#define COLOR_EMPTY     (0)
#define COLOR_LIMIT     (5)
#define AREA_BUFFLIMIT  (512)
#define true            (1)
#define false           (0)

/* GA̗אڏԂz */
unsigned char areapattern[AREA_LIMIT][6] = {
    {AREA_B, AREA_C, AREA_F, AREA_END, },                 // AcB,C,F
    {AREA_A, AREA_C, AREA_D, AREA_F, AREA_G, AREA_END, }, // BcA,C,D,F,G
    {AREA_A, AREA_B, AREA_D, AREA_END, },                 // CcA,B,D
    {AREA_B, AREA_C, AREA_E, AREA_G, AREA_H, AREA_END, }, // DcB,C,E,G,H
    {AREA_D, AREA_END, },                                 // EcD
    {AREA_A, AREA_B, AREA_G, AREA_END, },                 // FcA,B,G
    {AREA_B, AREA_D, AREA_F, AREA_H, AREA_END, },         // GcB,D,F,H
    {AREA_D, AREA_G, AREA_END, },                         // HcD,G
};

/* n} */
unsigned char areamap[AREA_LIMIT];

/* ߋ̃f[^ */
unsigned char areamapbuff[AREA_BUFFLIMIT][AREA_LIMIT];
unsigned char areabuff[AREA_BUFFLIMIT];
int queuefront; /* L[̐擪iɎoʒuj    */
int queuerear;  /* L[̖{1iɑ}ʒuj */

/* GÃe[u */
char areaname[] = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H'};


/* -------------------------------------------------------- */
/*  */
void init(void)
{
    int i;
    for (i = 0; i < AREA_LIMIT; i++)
        areamap[i] = 0;
    queuefront = 0;
    queuerear = 0;
}

/* -------------------------------------------------------- */
/* n}L[ɓ */
void enqueueareamap(unsigned char area)
{
    /* L[̏ԂƃL[t̏Ԃʂ邽߂ */
    /* queuefront̒O1͕K󂯂Ă */

    int newrear = (queuerear + 1) % AREA_BUFFLIMIT;

    if(newrear == queuefront) {
        fprintf(stderr, "buffer overflow\n");
        exit(0);
    }

    memcpy(areamapbuff[queuerear], areamap, sizeof(areamap));
    areabuff[queuerear] = area;
    queuerear = newrear;
}

/* n}L[o */
void dequeueareamap(unsigned char *area)
{
    if(queuefront == queuerear) {
        fprintf(stderr, "buffer underflow\n");
        exit(0);
    }
    memcpy(areamap, areamapbuff[queuefront], sizeof(areamap));
    *area = areabuff[queuefront];
    queuefront = (queuefront + 1) % AREA_BUFFLIMIT;
}

/* -------------------------------------------------------- */
/* ̐FuȂtrue */
int isusedcolor(unsigned char area, unsigned char color)
{
    unsigned char c, checkarea;
    int i = 0;
    while (areapattern[area][i] != AREA_END) {
        checkarea = areapattern[area][i];
        if (color == areamap[checkarea])
            return true;
        i++;
    }
    return false;
}

/* -------------------------------------------------------- */
/* ʂ̕\ */
void printarea(void)
{
    static int count = 0;
    char c;
    int i;

    count++;
    printf("%dڌ\n", count);
    for (i = 0; i < AREA_LIMIT; i++) {
        printf(" %c: %d ", areaname[i], areamap[i]);
    }
    printf("\n");
}

/* -------------------------------------------------------- */
/* hFT */
void colorsearch(void)
{
    unsigned char area, color;

    area = 0;
    enqueueareamap(0);
    printarea();

    while (true) {
        /* L[o */
        dequeueareamap(&area);

        /* eFh邩ǂׂ */
        for (color = 1; color < COLOR_LIMIT; color++) {
            if (!isusedcolor(area, color)) {
                areamap[area] = color;
                printarea();
                /* L[Ɋi[ */
                enqueueareamap(area + 1);
                if (area == AREA_LIMIT - 1) return;
            }
        }
    }
}

/* -------------------------------------------------------- */
int main(void)
{
    init();
    colorsearch();
    return 0;
}
