/* --------------------------------------------------------
   4FĂ݂
   ([DTŒׂCvOŃX^bNp)

                                     2003/11/14
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -------------------------------------------------------- */
#define AREA_LIMIT      (8)
#define AREA_A          (0)
#define AREA_B          (1)
#define AREA_C          (2)
#define AREA_D          (3)
#define AREA_E          (4)
#define AREA_F          (5)
#define AREA_G          (6)
#define AREA_H          (7)
#define AREA_END        (8)
#define COLOR_EMPTY     (0)
#define COLOR_LIMIT     (5)
#define AREA_BUFFLIMIT  (32)
#define true            (1)
#define false           (0)

/* GA̗אڏԂz */
unsigned char areapattern[AREA_LIMIT][6] = {
    {AREA_B, AREA_C, AREA_F, AREA_END, },                 // AcB,C,F
    {AREA_A, AREA_C, AREA_D, AREA_F, AREA_G, AREA_END, }, // BcA,C,D,F,G
    {AREA_A, AREA_B, AREA_D, AREA_END, },                 // CcA,B,D
    {AREA_B, AREA_C, AREA_E, AREA_G, AREA_H, AREA_END, }, // DcB,C,E,G,H
    {AREA_D, AREA_END, },                                 // EcD
    {AREA_A, AREA_B, AREA_G, AREA_END, },                 // FcA,B,G
    {AREA_B, AREA_D, AREA_F, AREA_H, AREA_END, },         // GcB,D,F,H
    {AREA_D, AREA_G, AREA_END, },                         // HcD,G
};

/* n} */
unsigned char areamap[AREA_LIMIT];

/* ߋ̃f[^ */
unsigned char areastackcount;
unsigned char areastack[AREA_BUFFLIMIT];
unsigned char colorstack[AREA_BUFFLIMIT];

/* GÃe[u */
char areaname[] = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H'};


/* -------------------------------------------------------- */
/*  */
void init(void)
{
    int i;
    for (i = 0; i < AREA_LIMIT; i++)
        areamap[i] = 0;
    areastackcount = 0;
}

/* -------------------------------------------------------- */
/* GAƐݒ肵FX^bN֐ݒ肷 */
void pushstack(unsigned char area, unsigned char color)
{
    areastack[areastackcount] = area;
    colorstack[areastackcount] = color;
    areastackcount++;
}

/* X^bNGAƐݒ肵F߂ */
void popstack(unsigned char *area, unsigned char *color)
{
    areastackcount--;
    *area = areastack[areastackcount];
    *color = colorstack[areastackcount];
}

/* -------------------------------------------------------- */
/* ̐FuȂtrue */
int isusedcolor(unsigned char area, unsigned char color)
{
    unsigned char c, checkarea;
    int i = 0;
    while (areapattern[area][i] != AREA_END) {
        checkarea = areapattern[area][i];
        if (color == areamap[checkarea])
            return true;
        i++;
    }
    return false;
}

/* -------------------------------------------------------- */
/* ʂ̕\ */
void printarea(void)
{
    static int count = 0;
    char c;
    int i;

    count++;
    printf("%dڌ\n", count);
    for (i = 0; i < AREA_LIMIT; i++) {
        printf(" %c: %d ", areaname[i], areamap[i]);
    }
    printf("\n");
}

/* h邱ƂłȂƂʒm */
void printnodraw(unsigned char area)
{
    printf("h܂ł: GA:%c\n", areaname[area]);
}

/* -------------------------------------------------------- */
/* hFT */
void colorsearch(void)
{
    unsigned char area, color;

    area = 0;
    color = 1;
    do {
        printarea();

        /* ǂ̐FhȂH */
        if (color >= COLOR_LIMIT) {
            /* h邱ƂłFȂ */
            /* h蕪Ԃ߂   */
            printnodraw(area);
            popstack(&area, &color);
            areamap[area] = COLOR_EMPTY;
            color++;
            continue;
        }

        if (isusedcolor(area, color)) {
            /* hȂΎ̐F */
            color++;
        } else {
            /* hȂFݒ */
            areamap[area] = color;
            /* X^bNareacolorۑ */
            pushstack(area, color);
            /* ̃GA */
            area++;
            color = 1;
        }
    } while(area < AREA_LIMIT);
}

/* -------------------------------------------------------- */
int main(void)
{
    init();
    colorsearch();
    printarea();
    return 0;
}
